/*
 * Created on Feb 17, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.gregor.rrd;

import java.awt.Color;
import java.awt.Color;
import java.awt.Font;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.io.OutputStream;
import java.util.LinkedList;
import java.util.List;

import com.gregor.util.TextUtils;

import org.jrobin.convertor.Convertor;
import org.jrobin.core.Archive;
import org.jrobin.core.Datasource;
import org.jrobin.core.Header;
import org.jrobin.core.RrdDb;
import org.jrobin.core.RrdException;
import org.jrobin.graph.RrdGraph;
import org.jrobin.graph.RrdGraphDef;

/**
 * @author dgregor
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RRDJRobin extends RRDTool {
    public static final String[] colors = {
	"0000ff",
	"00ff00",
	"00ffff",
	"ff0000",
	"ff00ff",
	"ffffff"
    };

    public Option[] options;

    public RRDJRobin() {
	options = new Option[] {
	    new Option("s", "start", true, "start time",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean) {
			       bean.setStart(Long.parseLong(option));
			   }
		       }),
	    new Option("e", "end", true, "end time",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean) {
			       bean.setEnd(Long.parseLong(option));
			   }
		       }),
	    new Option("t", "title", true, "title",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean)
			       throws RrdException {
			       bean.getGraphDef().setTitle(option);
			   }
		       }),
	    new Option("v", "vertical-label", true, "vertical label",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean)
			       throws RrdException {
			       bean.getGraphDef().setVerticalLabel(option);
			   }
		       }),
	    new Option("h", "height", true, "height",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean) {
			       bean.setHeight(Integer.parseInt(option));
			   }
		       }),
	    new Option("w", "width", true, "width",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean) {
			       bean.setWidth(Integer.parseInt(option));
			   }
		       }),
	    new Option("X", "units-exponent", true, "units exponent",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean)
			       throws RrdException {
			       int i = Integer.parseInt(option);
			       bean.getGraphDef().setUnitsExponent(i);
			   }
		       }),
	    new Option("l", "lower-limit", true, "lower limit",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean) {
			       bean.setLowerLimit(Double.parseDouble(option));
			   }
		       }),
	    new Option("u", "upper-limit", true, "upper limit",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean) {
			       bean.setUpperLimit(Double.parseDouble(option));
			   }
		       }),
	    new Option("r", "rigid", false, "rigid limits",
		       new OptionProcessor() {
			   public void process(String option, OptionBean bean) {
			       bean.setRigid(true);
			   }
		       })
	};
    }

    /* (non-Javadoc)
     * @see com.gregor.rrd.RRDTool#init()
     */
    public void init() throws IOException, RRDException {
	// TODO Auto-generated method stub

    }

    /* (non-Javadoc)
     * @see com.gregor.rrd.RRDTool#deInit()
     */
    public void deInit() throws IOException, RRDException {
	// TODO Auto-generated method stub

    }

    /* (non-Javadoc)
     * @see com.gregor.rrd.RRDTool#doCommand(java.lang.String,
     *                                       java.io.OutputStream)
     */
    public String[] doCommand(String command, OutputStream out)
	throws IOException, RRDException {
        String[] commandArray = tokenize(command, " \t", false);
        return doCommand(commandArray, out);
    }

    /* (non-Javadoc)
     * @see com.gregor.rrd.RRDTool#doCommand(java.lang.String[],
     *                                       java.io.OutputStream)
     */
    public String[] doCommand(String[] command, OutputStream out)
	throws IOException, RRDException {
	final String SUFFIX = ".jrb";

	if (command.length == 0) {
	    throw new IllegalArgumentException("No command specified");
	}
		
	if (command[0].equals("jrobin-import")) {
	    if (command.length < 3 || command.length > 4) {
		throw new IllegalArgumentException("Incorrect number of " +
						   "options.  Usage: " +
						   "jrobin-import <path to " +
						   "RRDTool binary> <RRD " +
						   "directory/file path> " +
						   "[converted file suffix]");
	    }
			
	    Convertor c = new Convertor(command[1], command[2],
					command.length == 4 ? command[3] :
					SUFFIX);
	    c.convert();

	    return null;
	} else if (command[0].equals("graph")) {
	    if (command.length <= 1) {
		throw new IllegalArgumentException("No file specified to " +
						   "graph command");
	    }
	    String file = command[1];
	    String[] graphCommand = new String[command.length - 2];
	    System.arraycopy(command, 2, graphCommand, 0, command.length - 2);
			
	    if (!file.equals("-")) {
		out = new FileOutputStream(file);
	    }
			
	    return createGraph(graphCommand, null, out);
	} else if (command[0].equals("dump")) {
	    if (command.length <= 1) {
		throw new IllegalArgumentException("No file specified to " +
						   "dump command");
	    }
	    if (command.length > 2) {
		throw new IllegalArgumentException("Too many arguments " +
						   "passed to dump command");
	    }
	    String file = command[1];
	    try {
		RrdDb rrdDb = new RrdDb(file);
		rrdDb.dumpXml("/dev/stdout");// XXX this should go to 'out'
	    } catch (RrdException e) {
		throw new RRDException("An exception occurred dumping the RRD:",
				       e);
	    }
	    return new String[0];
	} else if (command[0].equals("info")) {
	    PrintStream pout;
	    if (out == null) {
		pout = System.out;
	    } else {
		pout = new PrintStream(out);
	    }
	    if (command.length <= 1) {
		throw new IllegalArgumentException("No file specified to " +
						   "info command");
	    }
	    if (command.length > 2) {
		throw new IllegalArgumentException("Too many arguments " +
						   "passed to info command");
	    }
	    String file = command[1];
	    try {
		RrdDb rrdDb = new RrdDb(file);
		pout.println("filename = \"" + file + "\"");
		Header header = rrdDb.getHeader();
		pout.println("rrd_version = \"" +
			     header.getSignature() + "\"");
		pout.println("step = " + header.getStep());
		pout.println("last_update = " +
			     header.getLastUpdateTime());
		for (int i = 0; i < header.getDsCount(); i++) {
		    Datasource d = rrdDb.getDatasource(i);
		    pout.println("ds[" + d.getDsName() + "]." +
				 "type = \"" + d.getDsType() + "\"");
		    pout.println("ds[" + d.getDsName() + "]." +
				 "minimal_heartbeat = " +
				 d.getHeartbeat());
		    pout.println("ds[" + d.getDsName() + "]." +
				 "min = " + d.getMinValue());
		    pout.println("ds[" + d.getDsName() + "]." +
				 "max = " + d.getMaxValue());
		    //pout.println("ds[" + d.getDsName() + "]." +
		    //	 "last_ds = \"" + + "\"");
		    pout.println("ds[" + d.getDsName() + "]." +
				 "value = " + d.getLastValue());
		    pout.println("ds[" + d.getDsName() + "]." +
				 "unknown_sec = " + d.getNanSeconds());
		}
		for (int i = 0; i < header.getArcCount(); i++) {
		    Archive a = rrdDb.getArchive(i);
		    pout.println("rra[" + i + "].cf = \"" +
				 a.getConsolFun() + "\"");
		    pout.println("rra[" + i + "].rows = " +
				 a.getRows());
		    pout.println("rra[" + i + "].pdp_per_row = " +
				 a.getSteps());
		    pout.println("rra[" + i + "].xff = " +
				 a.getXff());
		    //pout.println("rra[" + i + "].cdp_prep[0].value = " +
		    //	 );
		    //pout.println("rra[" + i +
		    //	 "].cdp_prep[0].unknown_datapoints = " +
		    //	 );
		    //pout.println("rra[" + i + "].cdp_prep[1].value = " +
		    //	 );
		    //pout.println("rra[" + i +
		    //	 "].cdp_prep[1].unknown_datapoints = " +
		    //	 );
		}
	    } catch (RrdException e) {
		throw new RRDException("An exception occurred getting " +
				       "information about the RRD:", e);
	    }
	    return new String[0];
	} else {
	    throw new IllegalArgumentException("Unsupported command \"" +
					       command[0] + "\"");
	}
    }

    private String[] tokenize(String line, String delims,
			      boolean processQuoted) {
        List tokenList = new LinkedList();

        StringBuffer currToken = new StringBuffer();
        boolean quoting = false;
        boolean escaping = false;

        for (int i = 0; i < line.length(); i++) {
            char ch = line.charAt(i);

            if (escaping) {
                if (ch == 'n') {
                    currToken.append('\n');
                } else if (ch == 'r') {
                    currToken.append('\r');
                } else if (ch == 't') {
                    currToken.append('\t');
                } else if (ch == '\\') {
                    currToken.append('\\');
                } else {
                    currToken.append(ch);
                }
                escaping = false;
            } else if (ch == '\\') {
                if (quoting && !processQuoted)
                    currToken.append(ch);
                else
                    escaping = true;
            } else if (ch == '\"') {
                if (!processQuoted)
                    currToken.append(ch);
                if (quoting) {
                    quoting = false;
                } else {
                    quoting = true;
                }
            } else if (!quoting && delims.indexOf(ch) >= 0) {
                tokenList.add(currToken.toString());
                currToken = new StringBuffer();
            } else {
                currToken.append(ch);
            }

        }

        if (escaping || quoting) {
            throw new IllegalArgumentException("unable to tokenize string " +
					       line + " with token chars " +
					       delims);
        }

        tokenList.add(currToken.toString());

        return (String[]) tokenList.toArray(new String[tokenList.size()]);
    }
    
    private Color getColor(String colorValue) {
        int colorVal = Integer.parseInt(colorValue, 16);
        return new Color(colorVal);
    }

    /**
     * This constructs a graphDef by parsing the rrdtool style command and using
     * the values to create the JRobin graphDef. It does not understand the 'AT
     * style' time arguments however. Also there may be some rrdtool parameters
     * that it does not understand. These will be ignored. The graphDef will be
     * used to construct an RrdGraph and a PNG image will be created. An input
     * stream returning the bytes of the PNG image is returned.
     */
    public String[] createGraph(String[] commandArray, File workDir,
				OutputStream out)
	throws IOException, RRDException {
        try {
            RrdGraphDef graphDef = new RrdGraphDef();

	    int colorIndex = 0;

	    OptionBean bean = new OptionBean();

            for (int i = 0; i < commandArray.length; i++) {
                String arg = commandArray[i];

		if (arg.startsWith("--")) {
		    int index = arg.indexOf("=");
		    String argarg = null;
		    Option option = null;

		    if (index != -1) {
			argarg = arg.substring(index + 1);
			arg = arg.substring(2, index);
		    } else {
			arg = arg.substring(2);
		    }
		    for (index = 0; index < options.length; index++) {
			if (arg.equals(options[index].getLongOption())) {
			    option = options[index];
			    break;
			}
		    }
		    if (option != null) {
			if (option.hasArgument()) {
			    if (argarg == null) {
				if (i + 1 < commandArray.length) {
				    argarg = commandArray[++i];
				} else {
				    throw new RRDException("option --" + arg +
							   "must be followed " +
							   "by an argument.");
				}
			    }
			} else {
			    if (argarg != null) {
				throw new RRDException("option --" + arg +
						       "was passed an " +
						       "argument, but it " +
						       "does not allow " +
						       "arguments.");
			    }
			}
			option.runProcessor(argarg, bean);
		    } else {
			throw new RRDException("unknown option: --" + arg);
		    }
		} else if (arg.startsWith("-")) {
		    int index;
		    String argarg = null;
		    Option option = null;

		    arg = arg.substring(1);

		    for (index = 0; index < options.length; index++) {
			if (arg.equals(options[index].getShortOption())) {
			    option = options[index];
			    break;
			}
		    }
		    if (option != null) {
			if (option.hasArgument()) {
			    if (i + 1 < commandArray.length) {
				argarg = commandArray[++i];
			    } else {
				throw new RRDException("option -" + arg +
						       "must be followed " +
						       "by an argument.");
			    }
			}
			option.runProcessor(argarg, bean);
		    } else {
			throw new RRDException("unknown option: -" + arg);
		    }
                } else if (arg.startsWith("DEF:")) {
                    String definition = arg.substring("DEF:".length());
                    String[] def = tokenize(definition, ":", true);
                    String[] ds = tokenize(def[0], "=", true);
                    File dsFile = new File(workDir, ds[1]);
                    graphDef.datasource(ds[0], dsFile.getAbsolutePath(),
					def[1], def[2]);
                } else if (arg.startsWith("CDEF:")) {
                    String definition = arg.substring("CDEF:".length());
                    String[] cdef = tokenize(definition, "=", true);
                    graphDef.datasource(cdef[0], cdef[1]);
                
                } else if (arg.startsWith("LINE1:")) {
                    String definition = arg.substring("LINE1:".length());
                    String[] line1 = tokenize(definition, ":", true);
                    String[] color = tokenize(line1[0], "#", true);
		    Color c;
		    if (color.length < 2) {
			c = null;
		    } else {
			c = getColor(color[1]);
		    }
		    // XXX jRobin doesn't seem to allow blind graphing by not
		    // XXX specifying the color and my above hack, although
		    // XXX nice, isn't compatible with rrdtool.
		    graphDef.line(color[0], c,
				  (line1.length > 1 ? line1[1] : ""), 1);
                
                } else if (arg.startsWith("LINE2:")) {
                    String definition = arg.substring("LINE2:".length());
                    String[] line2 = tokenize(definition, ":", true);
                    String[] color = tokenize(line2[0], "#", true);
		    Color c;
		    if (color.length < 2) {
			c = null;
		    } else {
			c = getColor(color[1]);
		    }
                    graphDef.line(color[0], c,
				  (line2.length > 1 ? line2[1] : ""), 2);

                } else if (arg.startsWith("LINE3:")) {
                    String definition = arg.substring("LINE3:".length());
                    String[] line3 = tokenize(definition, ":", true);
                    String[] color = tokenize(line3[0], "#", true);
		    Color c;
		    if (color.length < 2) {
			c = null;
		    } else {
			c = getColor(color[1]);
		    }
                    graphDef.line(color[0], c,
				  (line3.length > 1 ? line3[1] : ""), 3);

                } else if (arg.startsWith("GPRINT:")) {
                    String definition = arg.substring("GPRINT:".length());
                    String gprint[] = tokenize(definition, ":", true);
                    String format = gprint[2];
                    format = format.replaceAll("%(\\d*\\.\\d*)lf", "@$1");
                    format = format.replaceAll("%s", "@s");
                    format = format.replaceAll("%%", "%");
                    graphDef.gprint(gprint[0], gprint[1], format);

                } else if (arg.startsWith("COMMENT:")) {
                    String comments[] = tokenize(arg, ":", true);
                    graphDef.comment(comments[1]);
                } else if (arg.startsWith("AREA:")) {
                    String definition = arg.substring("AREA:".length());
                    String area[] = tokenize(definition, ":", true);
                    String[] color = tokenize(area[0], "#", true);
		    Color c;
		    if (color.length < 2) {
			c = null;
		    } else {
			c = getColor(color[1]);
		    }
                    graphDef.area(color[0], c,
				  (area.length > 1 ? area[1] : ""));

                } else if (arg.startsWith("STACK:")) {
                    String definition = arg.substring("STACK:".length());
                    String stack[] = tokenize(definition, ":", true);
                    String[] color = tokenize(stack[0], "#", true);
		    Color c;
		    if (color.length < 2) {
			c = null;
		    } else {
			c = getColor(color[1]);
		    }
                    graphDef.stack(color[0], c,
				   (stack.length > 1 ? stack[1] : ""));
                
                } else {
                    throw new RRDException("Unrecognized graph argument: " +
					   arg);
                }
            }
            graphDef.setTimePeriod(bean.getStart(), bean.getEnd());
            graphDef.setGridRange(bean.getLowerLimit(), bean.getUpperLimit(),
				  bean.isRigid());
            graphDef.setDefaultFont(new Font("Monospaced", Font.PLAIN, 10));
            graphDef.setTitleFont(new Font("Monospaced", Font.PLAIN, 12));

            RrdGraph graph = new RrdGraph(graphDef, false);

            byte[] bytes = graph.getPNGBytes(bean.getWidth(), bean.getHeight());
            out.write(bytes);

	    BufferedImage bufferedImage = graph.getBufferedImage(0, 0);

	    return new String[] { bufferedImage.getWidth() + "x" +
				  bufferedImage.getHeight() };
        } catch (Exception e) {
            throw new RRDException("An exception occurred creating the graph.",
				   e);
        }
    }

    public class Option {
	private String m_shortOption;
	private String m_longOption;
	private boolean m_hasArgument;
	private String m_description;
	private OptionProcessor m_processor;

	public Option(String shortOption, String longOption,
		      boolean hasArgument, String description,
		      OptionProcessor processor) {
	    m_shortOption = shortOption;
	    m_longOption = longOption;
	    m_hasArgument = hasArgument;
	    m_description = description;
	    m_processor = processor;
	}

	public String getShortOption() {
	    return m_shortOption;
	}
	public String getLongOption() {
	    return m_longOption;
	}
	public boolean hasArgument() {
	    return m_hasArgument;
	}
	public String getDescription() {
	    return m_description;
	}
	public OptionProcessor getProcessor() {
	    return m_processor;
	}

	public void runProcessor(String option, OptionBean bean)
	    throws RrdException {
	    m_processor.process(option, bean);
	}
    }

    public interface OptionProcessor {
	public void process(String option, OptionBean bean) throws RrdException;
    }

    public class OptionBean {
	RrdGraphDef m_graphDef = new RrdGraphDef();

	long m_start;
	long m_end;
	int m_height = 100;
	int m_width = 400;
	double m_lowerLimit = Double.NaN;
	double m_upperLimit = Double.NaN;
	boolean m_rigid = false;

	public OptionBean() {
	    m_end = System.currentTimeMillis()/1000;
	    m_start = m_end - 60 * 60 * 24;
	}

	public RrdGraphDef getGraphDef() {
	    return m_graphDef;
	}
	public void setGraphDef(RrdGraphDef graphDef) {
	    m_graphDef = graphDef;
	}
	public long getStart() {
	    return m_start;
	}
	public void setStart(long start) {
	    m_start = start;
	}
	public long getEnd() {
	    return m_end;
	}
	public void setEnd(long end) {
	    m_end = end;
	}
	public int getHeight() {
	    return m_height;
	}
	public void setHeight(int height) {
	    m_height = height;
	}
	public int getWidth() {
	    return m_width;
	}
	public void setWidth(int width) {
	    m_width = width;
	}
	public double getLowerLimit() {
	    return m_lowerLimit;
	}
	public void setLowerLimit(double lowerLimit) {
	    m_lowerLimit = lowerLimit;
	}
	public double getUpperLimit() {
	    return m_upperLimit;
	}
	public void setUpperLimit(double upperLimit) {
	    m_upperLimit = upperLimit;
	}
	public boolean isRigid() {
	    return m_rigid;
	}
	public void setRigid(boolean rigid) {
	    m_rigid = rigid;
	}

    }
}
